#include "engine.h"
#include <input.h>
#include "scene.h"
#include "cameranode.h"
#include "resourcemanager.h"
#include "sparrowrenderer.h"

#include "tools/graph.h"
#include "tools/pathfinder.h"

int main(){
    CameraNode camera;
    RESOURCE_ADD(&camera, SceneNode, "camera");

    Scene scene("testScene");
    scene.addChild("camera");

    Engine engine;
    engine.getRenderer()->setCamera(&camera);
    engine.createWindow("test");
    engine.setScene("testScene");
    engine.start();

    GraphNode n1 = GraphNode();
    n1.setValue(1);
    GraphNode n2 = GraphNode();
    n2.setValue(2);
    GraphNode n3 = GraphNode();
    n3.setValue(3);
    GraphNode n4 = GraphNode();
    n4.setValue(4);
    GraphNode n5 = GraphNode();
    n5.setValue(5);

    n1.addNeighbours(&n2,6);
    n1.addNeighbours(&n3,3);
    n2.addNeighbours(&n4,2);
    n3.addNeighbours(&n4,20);
    n3.addNeighbours(&n2,2);
    n3.addNeighbours(&n5,10);

    std::vector<GraphNode*> path = PathFinder::a_star(&n1,&n4,true);
    std::cout << "Path Size: " << path.size() << std::endl;
    for(GraphNode* gn: path){
        std::cout << gn->getValue() << std::endl;
    }
}
