#include "loader.h"
#include <fstream>
#include <streambuf>
#include <image.h>
#include <SFML/Graphics/Image.hpp>

std::string* Loader::loadTextFile(const std::string &filename)
{
    std::ifstream t(filename);
    std::string *str = new std::string();

    t.seekg(0, std::ios::end);
    str->reserve(t.tellg());
    t.seekg(0, std::ios::beg);

    str->assign((std::istreambuf_iterator<char>(t)),
                std::istreambuf_iterator<char>());
    return str;
}

Image* Loader::loadImage(const std::string &filename, bool hasAlpha)
{
    sf::Image sfImg;
    sfImg.loadFromFile(filename);
    Image* img = new Image();
    img->depth = hasAlpha ? 32 : 24;
    img->width = sfImg.getSize().x;
    img->height = sfImg.getSize().y;
    int size = img->width*img->height*(img->depth/8);
    img->allocate(size);
    const sf::Uint8 *pixels = sfImg.getPixelsPtr();
    if(hasAlpha)
        memcpy(img->pixels, pixels, size);
    else
    {
        sf::Uint8 *ptr = (sf::Uint8*)img->pixels;
        for(int i=0; i<img->width*img->height; ++i)
            memcpy(ptr + i*3, pixels + i*4, 3);
    }
    return img;
}
